VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form frmPictures 
   Caption         =   "Pictures"
   ClientHeight    =   3765
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6495
   LinkTopic       =   "Form1"
   ScaleHeight     =   3765
   ScaleWidth      =   6495
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cdPicture 
      Left            =   2160
      Top             =   2520
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Select Image to Load"
      Filter          =   "Pictures (*.bmp;*.ico, *.jp*)|*.bmp;*.ico;*.jp*|All Files|*.*"
      FilterIndex     =   1
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Select Picture"
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   2415
   End
   Begin VB.ListBox lstNames 
      Height          =   3375
      ItemData        =   "frmPictures.frx":0000
      Left            =   0
      List            =   "frmPictures.frx":0002
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   360
      Width           =   2415
   End
   Begin VB.OLE oleImage 
      Height          =   1575
      Left            =   2400
      SizeMode        =   3  'Zoom
      TabIndex        =   2
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "frmPictures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private DB As Database
Private RS As Recordset

Private Sub cmdLoad_Click()
    On Error GoTo HardError
    
    'Select File
    cdPicture.ShowOpen
    
    'Load Picture
    oleImage.CreateEmbed cdPicture.filename
    
    'Save Filename
    RS.Edit
    RS!Picture = cdPicture.filename
    RS.Update
    
HardError:
End Sub

Private Sub Form_Load()
    'Connect to Database
    Set DB = OpenDatabase(App.Path & "\" & App.EXEName & ".mdb")
    Set RS = DB.OpenRecordset("Cards")
    
    'Build List
    cmdLoad.Enabled = False
    lstNames.Clear
    Do Until RS.EOF
        lstNames.AddItem RS!Name
        RS.MoveNext
    Loop
End Sub

Private Sub Form_Resize()
On Error GoTo HardError
    Me.ScaleMode = vbTwips
    'Incress list height
    lstNames.Height = Me.ScaleHeight - lstNames.Top
    
    'Resize picture to fill remaining area
    oleImage.Move oleImage.Left, 0, Me.ScaleWidth - oleImage.Left, Me.ScaleHeight

HardError:
End Sub

Private Sub lstNames_Click()
    'Find Record
    RS.MoveFirst
    Do Until RS!Name = lstNames.Text
        RS.MoveNext
    Loop
    
    'Load Picture
    If Not IsNull(RS!Picture) Then
        oleImage.CreateEmbed RS!Picture
    Else
        oleImage.Delete
    End If
    cmdLoad.Enabled = True
End Sub
