VERSION 5.00
Begin VB.Form frmProcess 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Photo IDs"
   ClientHeight    =   3255
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3135
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3255
   ScaleWidth      =   3135
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdData 
      Caption         =   "Information"
      Height          =   735
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   3135
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Print Back"
      Height          =   735
      Left            =   0
      TabIndex        =   2
      Top             =   2520
      Width           =   3135
   End
   Begin VB.CommandButton cmdPictures 
      Caption         =   "Pictures"
      Height          =   735
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   3135
   End
   Begin VB.CommandButton cmdFront 
      Caption         =   "Print Front"
      Height          =   735
      Left            =   0
      TabIndex        =   0
      Top             =   1680
      Width           =   3135
   End
End
Attribute VB_Name = "frmProcess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Vertical Alignment Positions
Private Enum VAlignmentPositions
    AlignTop
    AlignCenter
    AlignBottom
End Enum

Private Sub PrintBack(RS As Recordset, ByVal PLeft As Single, ByVal PTop As Single, img As StdPicture)
    Dim fnt     As StdFont
    Dim PWth    As Single

    'Draw Boxes
    Printer.Line (PLeft + 0.1, PTop + 0.1)-Step(1.3, 1.8), , B 'Thumb print
    
    'Print Picture - Logo
    PrintPicture img, PLeft + 1.75, PTop, 1, 1
    
    'Set Up Font
    Set fnt = New StdFont
    fnt.Name = "Arial"
    fnt.Italic = False
    fnt.Bold = False
    Printer.FontSize = 8

    'Print Pack Info
    PLeft = PLeft + 1.55
    PWth = 1.4
    PTop = PTop + 1

    'Print Notes
    PrintTextWrapped fnt, PLeft, PTop, 1.4, 1, Trim$(RS!Notes & ""), vbLeftJustify
End Sub

Private Sub PrintCard(RS As Recordset, ByVal PLeft As Single, ByVal PTop As Single)
    Dim fnt     As StdFont
    
    'Draw Boxes
    Printer.Line (PLeft, PTop)-Step(3, 2), , B
    Printer.Line (PLeft, PTop + 0.5)-Step(1.5, 1.5), , B
    
    'Print Picture
    If Not IsNull(RS!Picture) Then PrintPicture LoadPicture(RS!Picture), PLeft, PTop + 0.5, 1.5, 1.5
    
    'Set Up Font
    Set fnt = New StdFont
    fnt.Name = "Lucida Handwriting"
    fnt.Bold = True
    fnt.Italic = True
    fnt.Size = 12

    'Print Title
    PrintText fnt, PLeft, PTop + 0.15, 3, 0.35, "" & RS!Name, vbCenter, AlignCenter
    
    'Adjust font size for text
    fnt.Name = "Arial"
    fnt.Italic = False
    Printer.FontSize = 8

    'Print Pack Info
    PrintText fnt, PLeft + 0.05, PTop, 2.9, 0.15, "" & RS!Group, vbLeftJustify, AlignCenter
    PrintText fnt, PLeft + 0.05, PTop, 2.9, 0.15, "" & RS!Rank, vbCenter, AlignCenter
    PrintText fnt, PLeft + 0.05, PTop, 2.9, 0.15, "" & RS!Leader, vbRightJustify, AlignCenter

    'Adjust top and turn off Bold
    fnt.Bold = False
    PTop = PTop + 0.5
    
    'Print Address
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Address1, vbLeftJustify, AlignTop
    PTop = PTop + 0.15
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Address2, vbLeftJustify, AlignTop
    PTop = PTop + 0.15
    
    'Print Phone Numbers
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone1Name, vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone1Num, vbRightJustify, AlignTop
    PTop = PTop + 0.15
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone2Name, vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone2Num, vbRightJustify, AlignTop
    PTop = PTop + 0.15
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone3Name, vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone3Num, vbRightJustify, AlignTop
    PTop = PTop + 0.15
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone4Name, vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone4Num, vbRightJustify, AlignTop
    PTop = PTop + 0.15
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone5Name, vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "" & RS!Phone5Num, vbRightJustify, AlignTop
    PTop = PTop + 0.15
    
    'DOB
    PrintText fnt, PLeft + 1.55, PTop, 1.4, 0.15, "DOB:", vbLeftJustify, AlignTop
    PrintText fnt, PLeft + 2, PTop, 1.4, 0.15, "" & RS!DOB, vbLeftJustify, AlignTop
    Printer.Line (PLeft + 1.5, PTop)-Step(1.5, 0)
    PTop = PTop + 0.15
    
    'Labels for info
    PrintText fnt, PLeft + 1.5, PTop, 0.5, 0.15, "EYES", vbCenter, AlignTop
    PrintText fnt, PLeft + 2, PTop, 0.5, 0.15, "HAIR", vbCenter, AlignTop
    PrintText fnt, PLeft + 2.5, PTop, 0.25, 0.15, "WT", vbCenter, AlignTop
    PrintText fnt, PLeft + 2.75, PTop, 0.25, 0.15, "HGT", vbCenter, AlignTop
    PTop = PTop + 0.15

    'Labels info
    PrintText fnt, PLeft + 1.5, PTop, 0.5, 0.15, "" & RS!Eyes, vbCenter, AlignTop
    PrintText fnt, PLeft + 2, PTop, 0.5, 0.15, "" & RS!Hair, vbCenter, AlignTop
    PrintText fnt, PLeft + 2.5, PTop, 0.25, 0.15, "" & RS!Weight, vbCenter, AlignTop
    PrintText fnt, PLeft + 2.75, PTop, 0.25, 0.15, "" & RS!Height, vbCenter, AlignTop
    PTop = PTop + 0.15
End Sub

Private Function PrintPicture(img As StdPicture, ByVal PLeft As Single, ByVal PTop As Single, ByVal PWidth As Single, ByVal PHeight As Single)
    Dim sclx As Single
    Dim scly As Single
    Dim sDim As Single
    
    'Determins largest scaling
    sclx = img.Width / PWidth
    scly = img.Height / PHeight
    
    If sclx < scly Then
        'fits best vertically
        
        'Determine scale width
        sDim = img.Width / scly
        
        'Paint Picture
        Printer.PaintPicture img, PLeft + ((PWidth - sDim) / 2), PTop, sDim, PHeight
    Else
        'fits best horizontally
        
        'Determine scale width
        sDim = img.Height / sclx
        
        'Paint Picture
        Printer.PaintPicture img, PLeft, PTop + ((PHeight - sDim) / 2), PWidth, sDim
    End If
End Function

Private Function PrintText(fnt As StdFont, ByVal PLeft As Single, ByVal PTop As Single, ByVal PWidth As Single, ByVal PHeight As Single, sText As String, HAlign As AlignmentConstants, VAlign As VAlignmentPositions)
    Dim Wth As Single
    Dim Hgt As Single
    
    'find text size
    Set Printer.Font = fnt
    Wth = Printer.TextWidth(sText)
    Hgt = Printer.TextHeight(sText)
    
    'Position Horizontally
    Select Case HAlign
    Case vbLeftJustify:     Printer.CurrentX = PLeft
    Case vbCenter:          Printer.CurrentX = PLeft + (PWidth - Wth) / 2
    Case vbRightJustify:    Printer.CurrentX = PLeft + PWidth - Wth
    Case Else:              Printer.CurrentX = PLeft
    End Select
    
    'Position Vertically
    Select Case VAlign
    Case AlignTop:          Printer.CurrentY = PTop
    Case AlignCenter:       Printer.CurrentY = PTop + (PHeight - Hgt) / 2
    Case AlignBottom:       Printer.CurrentY = PTop + PHeight - Hgt
    Case Else:              Printer.CurrentY = PTop
    End Select
    
    'Print Text
    Printer.Print sText
End Function

Private Function PrintTextWrapped(fnt As StdFont, ByVal PLeft As Single, ByVal PTop As Single, ByVal PWidth As Single, ByVal PHeight As Single, ByVal sText As String, HAlign As AlignmentConstants)
    Dim Wth     As Single
    Dim Hgt     As Single
    Dim sCur    As String
    Dim iPos    As Integer
    
    'Set Font
    Set Printer.Font = fnt
    sText = Trim(sText)
    
    'Process all Text
    Do Until sText = ""
        'Copy Remaining Text
        sCur = sText
        
        'find text that fits
        Do
            'Measure Text
            Wth = Printer.TextWidth(sCur)
            Hgt = Printer.TextHeight(sCur)
            
            'Exit if Width Fits
            If Wth <= PWidth Then Exit Do
            
            'Remove last word
            iPos = inStrRev(1, sCur, " ", vbBinaryCompare)
            If iPos > 0 Then
                'Word Found, Remove
                sCur = Left(sCur, iPos - 1)
            Else
                'No Word Found, Remove last letter
                sCur = Left(sCur, Len(sCur) - 1)
            End If
        Loop
        
        'See if Hgt exceeded, remove found text from set
        PHeight = PHeight - Hgt
        If PHeight < 0 Then Exit Do
        sText = Trim(Mid(sText, Len(sCur) + 1))
        
        'Position Horizontally
        Select Case HAlign
        Case vbLeftJustify:     Printer.CurrentX = PLeft
        Case vbCenter:          Printer.CurrentX = PLeft + (PWidth - Wth) / 2
        Case vbRightJustify:    Printer.CurrentX = PLeft + PWidth - Wth
        Case Else:              Printer.CurrentX = PLeft
        End Select
        
        'Position Vertically
        Printer.CurrentY = PTop
        PTop = PTop + Hgt
    
        'Print Text
        Printer.Print sCur
    Loop
End Function

Private Sub cmdBack_Click()
    Dim RS As Recordset
    Dim DB As Database
    Dim img As StdPicture
    
    Dim x As Long
    Dim y As Long
    
    
    'Load Picture
    Set img = LoadPicture(".\Pictures\cublogographic.gif")

    'Connect to Database
    Set DB = OpenDatabase(App.Path & "\" & App.EXEName & ".mdb")
    Set RS = DB.OpenRecordset("Select * From Cards Where Process = True Order by [Name]")
    
    'Set up printer
    Printer.ScaleMode = vbInches
    Me.ScaleMode = vbInches
    Printer.FillStyle = vbFSTransparent
    
    Do
        For y = 0 To 4
            For x = 0 To 1
                PrintBack RS, 1 + x * 3, 0.4 + y * 2, img
            Next
            
'            'Debugging Code
'            If y = 1 Then
'                Printer.EndDoc
'                Exit Do
'            End If
            
            'Get Next Record
            RS.MoveNext
            If RS.EOF Then Exit For
        Next
        
        'Finish Page
        Printer.EndDoc
    Loop Until RS.EOF

    Set RS = Nothing
    Set DB = Nothing
End Sub

Private Sub cmdData_Click()
    frmDataEntry.Show
End Sub

Private Sub cmdFront_Click()
    Dim RS As Recordset
    Dim DB As Database
    
    Dim x As Long
    Dim y As Long
    
    
    'Connect to Database
    Set DB = OpenDatabase(App.Path & "\" & App.EXEName & ".mdb")
    Set RS = DB.OpenRecordset("Select * From Cards Where Process = True Order by [Name]")
    
    
    'Set up printer
    Printer.ScaleMode = vbInches
    Me.ScaleMode = vbInches
    Printer.FillStyle = vbFSTransparent
    
    Do
        For y = 0 To 4
            For x = 0 To 1
                PrintCard RS, 1 + x * 3, 0.4 + y * 2
            Next
            
'            'Debugging Code
'            If y = 1 Then
'                Printer.EndDoc
'                Exit Do
'            End If
            
            'Get Next Record
            DoEvents
            RS.MoveNext
            If RS.EOF Then Exit For
        Next
        
        'Finish Page
        Printer.EndDoc
'        MsgBox "Page Finished, Press OK to continue", , "Page Complete"
    Loop Until RS.EOF

    Set RS = Nothing
    Set DB = Nothing
End Sub

Private Sub cmdPictures_Click()
    frmPictures.Show
End Sub

Private Function inStrRev(ByVal iStart%, sText$, sFind$, cType As VbCompareMethod) As Integer
    Dim iPos%
        
    Do
        'Save Position
        inStrRev = iPos
        
        'Find Next Position
        iPos = InStr(iPos + 1, sText, sFind, cType)
    Loop Until iPos = 0
End Function
